import { BaseSelectProps } from '@mui/material'
import { useEffect, useState } from 'react'
import axios from '../../config/axios'
import { SingleSelect } from '../Input'

type FacultySelectorProps = {
  name?: string
  label: string
  filters?: {
    departmentId: number | string
    isSearch: boolean
    isActive: boolean
    type: string
  }
  required?: boolean
  onChange?: (value: any) => void
  allowAll?: boolean
  error?: boolean
  helperText?: string
  api?: string
} & BaseSelectProps
const FacultySelector = (props: FacultySelectorProps) => {
  const {
    name,
    required = false,
    label,
    multiple = false,
    filters,
    allowAll = true,
    api = '/hrms/employees',
  } = props
  const [options, setOptions] = useState([])
  const [prevDepartmentId, setPrevDepartmentId] = useState(null)
  const handleOpen = () => {
    if (filters) {
      if (filters.departmentId && filters.departmentId !== prevDepartmentId) {
        setOptions([])
        axios
          .get(api, {
            params: filters,
          })
          .then((response) => {
            setOptions(response.data.data)
            setPrevDepartmentId(filters.departmentId)
          })
          .catch((error) => {
            console.error('Error fetching data from the API:', error)
          })
      }
    } else if (options.length === 0) {
      axios
        .get(api)
        .then((response) => {
          setOptions(response.data.data)
        })
        .catch((error) => {
          console.error('Error fetching data from the API:', error)
        })
    }
  }
  useEffect(() => {
    if (props?.value && props.value != 'all') {
      handleOpen()
    }
  }, [props.value])

  const handleOptions =
    options.length > 0
      ? [
          ...(allowAll ? [{ value: 'all', label: 'All' }] : []),
          ...options.map((item) => ({
            label: `${item.fullName}`,
            value: `${item.userId}`,
          })),
        ]
      : allowAll
      ? [{ value: 'all', label: 'All' }]
      : []

  return (
    <SingleSelect
      name={name}
      label={label}
      required={required}
      options={handleOptions}
      onOpen={handleOpen}
      defaultValue="all"
      {...props}
    />
  )
}
export default FacultySelector
